/**
 * @file ylockobject.h
 * @brief Ʊѥ֥
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-3-12
 *
 * Copyright (C) 2004, Yashiro Takeshi
 */

#ifndef DEFINE_H_YLOCKOBJECT
#define DEFINE_H_YLOCKOBJECT

#include <basic.h>
#include <btron/taskcomm.h>
#include "yexception.h"
#include "ysemaphore.h"

/** Ʊѥ֥
 *
 * ޥեˤƱ¾˹ԤƱѥ֥Ȥ
 * ޤ
 */
class YLockObject {
public:
  /** 󥹥ȥ饯
   *
   * Ʊѥ֥Ȥ(initialLocktrueǤȤ)
   * ֥Ȥåޤ
   * @param sem ޥե֥
   * @param initialLock ֥Ȥ˥å
   */
  YLockObject(YSemaphore* sem, bool initialLock = true) {
    locked = false;
    semaphore = sem;

    if (initialLock){
      lock();
    }
  }

  /** ǥȥ饯
   *
   * Ʊѥ֥Ȥ򥢥åƱѥ֥Ȥޤ
   */
  ~YLockObject() {
    unlock();
  }

  /// Ʊѥ֥ȤΥå
  void lock() {
    if (!locked && semaphore != 0){
      semaphore->lock();
      locked = true;
    }
  }

  /// Ʊѥ֥ȤΥå
  void unlock() {
    if (locked && semaphore != 0){
      semaphore->unlock();
      locked = false;
    }
  }

private:
  /// Ʊ¾ѥޥե
  YSemaphore* semaphore;

  /// åƤ뤫ݤ
  bool locked;
};

#endif // DEFINE_H_YLOCKOBJECT
