/**
 * @file ysemaphore.h
 * @brief ޥե
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-01-30
 *
 * Copyright (C) 2004, Yashiro Takeshi
 */

#ifndef DEFINE_H_YSEMAPHORE
#define DEFINE_H_YSEMAPHORE

#include <basic.h>
#include <btron/taskcomm.h>
#include "yexception.h"

/** ޥեط㳰
 *
 * ޥեط㳰򰷤ޤ
 */
class YSemaphoreException : public YException {
public:
  YSemaphoreException(W n = 0) : YException(n) {}
  YSemaphoreException(const YString& str, W n = 0)
    : YException(str, n) {}
};

struct YSemaphoreInstance {
  W sem_id;
  W refcount;
};

/** ޥե
 *
 * ֤Ʊ¾ΤΥޥե򥯥饹Ǥ
 * cre_sem, wai_sem ʤɤδؿΥåѤȤʤäƤꡢ
 * ե󥹥󥿤ˤ뼫ưŪʥޥեκԤޤ
 *
 * Х̾ȤŪ TCʸ "YLBޥե" 
 * ޤ
 *
 * ̾YLockObject饹ѤơŪ˻Ѥ뤳Ȥ㳰
 * δ˾ޤȹͤޤ
 */
class YSemaphore {
private:
  mutable YSemaphoreInstance *sem;
  W max_count;
  W mode;

  /// ޥեǻѤ륻ޥեIDμ
  W getInternalSemaphoreID() const;

  /// ޥեμΤμ
  YSemaphoreInstance* getInstance() const;

  /// ޥեλȸȤ򸺤餹
  void reductInstanceReferrer();

protected:

public:
  /// 󥹥ȥ饯
  YSemaphore(W cnt = 1, W mode = SEM_EXCL);
  
  /** ǥȥ饯
   *
   * ǥȥ饯ƱΥޥե¸ߤȤޥեϺޤ
   */
  ~YSemaphore() {
    W global_sem = getInternalSemaphoreID();
    wai_sem(global_sem, T_FOREVER);
    // ƥ륻󳫻
    try {
      reductInstanceReferrer();
    }
    catch (...){
      sig_sem(global_sem);
      throw;
    }
    // ƥ륻λ
    sig_sem(global_sem);
  }

  // ԡ󥹥ȥ饯
  YSemaphore(const YSemaphore& src);

  /// ޥեγ
  void lock();

  /// ޥեβ
  void unlock();

  /// 黻
  const YSemaphore& operator=(const YSemaphore& src);
  
};

#endif // DEFINE_H_YSEMAPHORE
